/*
 * Copyright (C) 2007-2019 Artima, Inc. All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Example code from:
 *
 * Programming in Scala, Fifth Edition
 * by Martin Odersky, Lex Spoon, Bill Venners, and Frank Sommers
 *
 * http://booksites.artima.com/programming_in_scala_5ed
 */

package org.stairwaybook.builtincontrolstructures

object Match {
  def match1(args: Array[String]): Unit = {
    val firstArg = if !args.isEmpty then args(0) else ""
    
    firstArg match
      case "salt" => println("pepper")
      case "chips" => println("salsa")
      case "eggs" => println("bacon")
      case _ => println("huh?")
  }

  def match2(args: Array[String]): Unit = {
    val firstArg = if !args.isEmpty then args(0) else ""
    
    val friend =
      firstArg match
        case "salt" => "pepper"
        case "chips" => "salsa"
        case "eggs" => "bacon"
        case _ => "huh?"
    
    println(friend)
  }

  def main(args: Array[String]): Unit = {
    Match.match1(Array())
    Match.match1(Array("foo"))
    Match.match1(Array("eggs"))

    Match.match2(Array("chips"))
  }
}

